SystemOrganization addCategory: #GroupManager!

Object subclass: #GroupManager
	instanceVariableNames: 'groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GroupManager'!

!GroupManager methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/16/2011 17:52'!
addAGroup

	| entry |
	entry := StandardWindow new textEntry: 'Name of the new group:' title: 'Create a new group' entryText: 'MyNewGroupName'.
	entry ifNotNil: [
		self groups 
			at: entry
			ifPresent: [:gps | self openError ]
			ifAbsent: [ self groups at: entry put: OrderedCollection new]].! !

!GroupManager methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/16/2011 18:01'!
addAGroupSilentlyNamed: entry

	self groups 
		at: entry
		ifPresent: [:gps | self openError ]
		ifAbsent: [ self groups at: entry put: OrderedCollection new]! !

!GroupManager methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/17/2011 11:23'!
addAGroupSilentlyNamed: entry with: aCollection

	self groups 
		at: entry
		ifPresent: [:gps | 
			self openError.
			^false]
		ifAbsent: [ 
			self groups at: entry put: aCollection.
			^ true]! !

!GroupManager methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/16/2011 18:04'!
at: aName

	^ self groups at: aName! !

!GroupManager methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/16/2011 17:48'!
groups

	^ groups ifNil: [ groups := Dictionary new ]! !

!GroupManager methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/16/2011 17:54'!
groupsClassesAt: aName

	^ self groups at: aName! !

!GroupManager methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/16/2011 17:54'!
groupsNames

	^ self groups keys sort! !

!GroupManager methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/16/2011 17:57'!
openDialogOn: aGroup

	^ StandardWindow new questionWithoutCancel: ('Dou you really want to delete the group named ', aGroup) title: 'Are you sure ?'! !

!GroupManager methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/16/2011 17:52'!
openError

	StandardWindow new alert: 'This group already exists' title: 'Already exists'! !

!GroupManager methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/16/2011 18:40'!
remove: anElement from: aGroup

	(self groups at: aGroup) remove: anElement! !

!GroupManager methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/16/2011 17:56'!
removeAGroup: aGroup

	| answer |
	aGroup ifNil: [^ self].
	answer := self openDialogOn: aGroup.
	answer ifTrue: [ self groups removeKey: aGroup ].! !

!GroupManager methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 3/16/2011 18:27'!
renameAGroup: aGroup

	| entry |
	entry := StandardWindow new textEntry: 'New name of the group:' title: 'Rename a group' entryText: 'MyGroupNewName'.
	entry ifNotNil: [
		self groups 
			at: entry
			ifPresent: [:gps | self openError ]
			ifAbsent: [ 
				self groups at: entry put: (self groups at: aGroup).
				self groups removeKey: aGroup]].
		^entry! !
